package com.breezejs.save;

import java.beans.PropertyDescriptor;

import com.breezejs.util.Assert;
import com.breezejs.util.Reflect;

public class AutoGeneratedKey {
	public Object entity;
	public AutoGeneratedKeyType type;
	public String propertyName;
	public Object tempValue;
	public Object realValue;
	private PropertyDescriptor propertyDescriptor;
	
	public AutoGeneratedKey(Object entity, String propertyName, String autoGeneratedKeyType) {
		Assert.notNull(entity, "entity");
		Assert.notNull(propertyName, "propertyName");
		Assert.notNull(autoGeneratedKeyType, "autoGeneratedKeyType");
		this.entity = entity;
		this.propertyName = propertyName;
		this.type = AutoGeneratedKeyType.valueOf(autoGeneratedKeyType);
	}
	
	public PropertyDescriptor getPropertyDescriptor() {
		if (propertyDescriptor == null) {
			propertyDescriptor = Reflect.findPropertyDescriptor(entity.getClass(), propertyName);
		}
		return propertyDescriptor;
	}
	
}
